require("waar") --Loads WaaR.lua

--GLOBAL DEFINES (TO BE REDUCED!)

function WaaRInit()
	if not global.WaterGlobalArea then global.WaterGlobalArea = {} end
	if not global.OPLocate then global.OPLocate = {} end
	if not global.OPACT then global.OPACT = {} end
	if not CWtr then CWtr = 0 end
	if not CDpWtr then CDpWtr = 0 end
	if not AmountWtr then AmountWtr = 1 end
	if not UsedAmount then UsedAmount = 0 end
	if not LastWaterFlow then LastWaterFlow = 0 end
	if not OPStart then OPStart = 0 end
	if not OPFinished then OPFinished = 0 end
	if not global.OPCount then global.OPCount = {} end
	if not global.LastWF then global.LastWF = 0 end
	if not global.WorldFlow then global.WorldFlow = 0 end
end

function WaterRandom(i)
	local WaterTiles = (global.WaterGlobalArea[i]["ShallowWater"] + global.WaterGlobalArea[i]["DeepWater"])
	local finalper = 20
	local TilePerPercent = math.floor((WaterTiles / finalper) * 0.8)
	if TilePerPercent < 1 then
		TilePerPercent = 1
	end
	local randnotiles = math.random(1,TilePerPercent)
	for a = 1, randnotiles, 1 do
		local rand = math.random(1,WaterTiles)
		game.surfaces[1].set_tiles({global.WaterGlobalArea[i]["WaterRepArea"][rand]})
	end
end

function SearchPattern (SearchPosition, WASearchQueue)							-- Function to Setup SearchPattern
	local north = {x = SearchPosition.x, y = SearchPosition.y-1}				-- Create Local North Table make it equal to SearchPostion -1 y
	local east  = {x = SearchPosition.x+1, y = SearchPosition.y}				-- Create Local East Table make it equal to SearchPostion +1 x
	local south = {x = SearchPosition.x, y = SearchPosition.y+1}				-- Create Local South Table make it equal to SearchPostion +1 y
	local west  = {x = SearchPosition.x-1, y = SearchPosition.y}				-- Create Local West Table make it equal to SearchPostion -1 x
	WASearchQueue[#WASearchQueue+1] = north
	WASearchQueue[#WASearchQueue+1] = east
	WASearchQueue[#WASearchQueue+1] = south
	WASearchQueue[#WASearchQueue+1] = west
    return WASearchQueue														-- Return WASearchQueue Table as Result
end

function GridRef (SearchPosition)
	return string.format ("%.1f , %.1f", SearchPosition.x , SearchPosition.y)	-- Print SearchPosition X, Y CoOrds as String
end

function IsWater(SearchPosition, OPsurface)
	local tile = OPsurface.get_tile(SearchPosition.x,SearchPosition.y).name 		-- Get Name of Tile by looking on the surface by using SearchPosition Variable
	if tile == "water" or tile =="deepwater" then 								-- IF Water or Deepwater THEN
		return true																-- Return TRUE
	else																		-- Otherwise
		return false 															-- Return False
	end																			-- NOT Water or Deepwater
	game.print("NOT A WATER TILE")												-- Print Not A Water Tile
end

function WaterType(SearchPosition, OPsurface)
	local tile = OPsurface.get_tile(SearchPosition.x,SearchPosition.y).name 		-- Get Name of Tile by looking on the surface by using SearchPosition Variable
	if tile == "water" then														-- IF Water
		return true																-- Return TRUE
	elseif tile == "deepwater" then											    -- ELSE IF Deepwater
		return false															-- Return False
	else																		-- Else		
		game.print("Not A Type of Water Tile")													-- Error
	end
end	

function GlobalWaterArea()
	GetWaterArea(OPposition,OPsurface)
	CalculatedWaterTotal()
	global.WaterGlobalArea[#global.WaterGlobalArea+1] = {["AmountWtr"] = AmountWtr,["Depleted"] = 0,["ShallowWater"] = CWtr, ["DeepWater"] = CDpWtr,["Percent"] = 0,["RandPercent"] = 79, ["WaterRepArea"] = WaterRepArea, ["OPs"] = 0}
	if #global.WaterGlobalArea > 1 then
		WGAC()
	end
	OPA()
	OPAC()
end

function WGAC()
	for i = 1, #global.WaterGlobalArea+1, 1 do
		for j = #global.WaterGlobalArea, 1, -1 do
			if i >= j then
				--game.print("DO NOTHING")
			elseif global.WaterGlobalArea[i]["AmountWtr"] == global.WaterGlobalArea[j]["AmountWtr"] then
				--game.print("SAME AREA")
				table.remove(global.WaterGlobalArea,j)
			else 
				--game.print("DIFFERENT AREAS")
			end
		end
	end
end

function OPA()
	for a = 1, #global.OPCount, 1 do ----- FOR EACH OFFSHORE PUMP
		local OPPX = global.OPLocate[a]["OPposition"]["x"]
		local OPPY = global.OPLocate[a]["OPposition"]["y"]
		for b = 1, #global.WaterGlobalArea, 1 do ---- FOR EACH WATERGLOBALAREA
			local WRAT = global.WaterGlobalArea[b]["ShallowWater"]+global.WaterGlobalArea[b]["DeepWater"]
			for c = 1, WRAT, 1 do ---- FOR EVERY TILE IN AREA
				local WRAPX = global.WaterGlobalArea[b]["WaterRepArea"][c]["position"]["x"]
				local WRAPY = global.WaterGlobalArea[b]["WaterRepArea"][c]["position"]["y"]
				if WRAPX == OPPX then
					if WRAPY == OPPY then
						--game.print("TRUE FOR X AND Y - A MATCH")
						global.OPLocate[a]["OPSameAs"] = b
					else
						--game.print("NO MATCH FOR Y")
					end
				else
					--game.print("FALSE FOR X")
				end
			end
		end
	end
end

function OPAC()
	for a = 1, #global.WaterGlobalArea, 1 do
		table.insert(global.OPACT, a, 0)
	end
	for a = 1, #global.WaterGlobalArea, 1 do --- FOR EACH WATER AREA
		for b = 1, #global.OPCount, 1 do 		--- FOR EACH OFFSHORE PUMP
			if global.OPLocate[b]["OPSameAs"] == a then
				global.OPACT[a] = global.OPACT[a] + 1		
			end
		end
		global.WaterGlobalArea[a]["OPs"] = global.OPACT[a]
	end
end

function GetWaterArea(OPposition,OPsurface) 										-- Get Water Area Function
	WaterRepArea = {}																-- Table WaterArea
	local WASearchQueue = {OPposition}												-- Table WaterAreaSearchQueue
	local WASearched = {}															-- Table WaterAreaSearched
	CWtr = 0
	CDpWtr = 0
	while #WASearchQueue > 0 do														-- WHILE there is a WASerachQueue
		local SearchPosition = WASearchQueue[1]										-- Convert Offshore Pump Position into SearchPosition
		if WASearched[GridRef(SearchPosition)] ~= true then							-- IF GridRef has not been searched
			if IsWater(SearchPosition, OPsurface) == false then						-- IF IsWater is FALSE then
				WASearched[GridRef(SearchPosition)] = true							-- GridRef has been Searched
			else																	-- ELSE IsWater is TRUE then
				if WaterType (SearchPosition, OPsurface) == true then					-- IF Water Type is "water"
					WaterRepArea[#WaterRepArea+1] = {["name"] = "sand-3" , ["position"] = {["x"] = SearchPosition.x, ["y"] = SearchPosition.y}}
					CWtr = CWtr + 1
				else
					WaterRepArea[#WaterRepArea+1] = {["name"] = "dry-dirt" , ["position"] = {["x"] = SearchPosition.x, ["y"] = SearchPosition.y}}
					CDpWtr = CDpWtr + 1
				end
				WASearched[GridRef(SearchPosition)] = true									-- Make SearchPosition TRUE in WASerached
				SearchPattern(SearchPosition, WASearchQueue)								-- Run SearchPattern Function Passing SearchPosition and WASearchQueue
				table.remove (WASearchQueue,1)												-- Remove from WASearchQueue
			end																				-- IF IsWater isn't TRUE or False 
		else	
			table.remove (WASearchQueue,1)													-- Remove from WASearchQueue
		end	
	end
end

function CalculatedWaterTotal()
	local TotalArea = CWtr + CDpWtr
	local WATER = 3000 
	local DEEPWATER = 10000
	local PBonus = 0.01 
	local WBonus = 0.5 
	local PDBonus = 1 
	local LBonus = 1.5 
	local GLBonus = 2 
	local SBonus = 2.5 
    local OBonus = 3 
	AmountWtr = (CWtr * WATER) + (CDpWtr * DEEPWATER)
	if TotalArea < 4 then
		--game.print("PUDDLE")
		AmountWtr = AmountWtr * PBonus
	elseif TotalArea == 4 then
		--game.print("WELL")
		AmountWtr = AmountWtr * WBonus
	elseif TotalArea > 4 and TotalArea <= 100 then
		--game.print("POND")
		AmountWtr = AmountWtr * PDBonus
	elseif TotalArea > 100 and TotalArea <= 1000 then
		--game.print("LAKE")
		AmountWtr = AmountWtr * LBonus
	elseif TotalArea > 1000 and TotalArea <= 10000 then
		--game.print("GREAT LAKE")
		AmountWtr = AmountWtr * GLBonus
	elseif TotalArea > 10000 and TotalArea <= 100000 then
		--game.print("SEA")
		AmountWtr = AmountWtr * SBonus
	else
		--game.print("OCEAN")
		AmountWtr = AmountWtr * OBonus
	end
end

function DepleatedWaterArea()
	for i = 1, #global.WaterGlobalArea, 1 do
		if global.WaterGlobalArea[i]["Depleted"] ~= 1 then
			local Percent = global.WaterGlobalArea[i]["Percent"]
			--game.print(Percent)
			if Percent <= 80 then
				--game.print("IN NORMAL BOUNDS")
			elseif Percent > 80 and Percent < 100 then
				local RP = global.WaterGlobalArea[i]["RandPercent"]
				if (Percent - RP) >= 1 then
					WaterRandom(i)
					global.WaterGlobalArea[i]["RandPercent"] = Percent
				end
			elseif Percent >= 100 then
				for a = 1, #global.OPCount, 1 do
					if global.OPLocate[a]["OPSameAs"] == i then
						local OPD = global.OPLocate[a]["OPdirection"]
						local OPE = global.OPLocate[a]["OPentity"]
						local OPP = global.OPLocate[a]["OPposition"]
						global.OPLocate[a]["Active"] = 0
						global.WaterGlobalArea[i]["Depleted"] = 1
						game.surfaces[1].create_entity{name="offshore-pump-nofluid",position = OPP,direction = OPD,force = "player"}
						OPE.destroy()
						game.surfaces[1].set_tiles(global.WaterGlobalArea[i]["WaterRepArea"])													-- Set Tiles to those in WaterArea Table
					end
				end
			end
		end
	end
end

function WaterAreaUsed(a)
	for i = 1, #global.WaterGlobalArea, 1 do
		local WaterSize = global.WaterGlobalArea[i]["AmountWtr"]
		if global.OPLocate[a]["OPSameAs"] == i then
			local WaterAreaUsed = (global.OPLocate[a]["OPflow"] / WaterSize) * 100
			local Percent = global.WaterGlobalArea[i]["Percent"] + WaterAreaUsed
			global.WaterGlobalArea[i]["Percent"] = Percent
		end
	end
end

function CheckFlow(a)
	local FlowRate = global.WorldFlow - global.LastWF
	local WATERPERTICK = 20
	if FlowRate > 0 then
		global.OPLocate[a]["OPflow"] = WATERPERTICK
	else
		global.OPLocate[a]["OPflow"] = 0
	end
end

function CheckActive()
	for o = 1, #global.OPLocate, 1 do
		if global.OPLocate[o]["Active"] == 0 then
			if global.OPLocate[o]["OPentity"].valid and global.OPLocate[o]["OPentity"].neighbours[1][1] then
				global.OPLocate[o]["Active"] = 1
			end
		elseif global.OPLocate[o]["Active"] == 1 then
			if global.OPLocate[o]["OPentity"].valid and not global.OPLocate[o]["OPentity"].neighbours[1][1] then
				global.OPLocate[o]["Active"] = 0
			end
		end
	end
end

function CheckWater ()
	global.WorldFlow = math.ceil(game.players[1].force.fluid_production_statistics.get_input_count("water"))
	if #global.OPLocate > 0 then
		CheckActive()
		for a = 1, #global.OPLocate, 1 do
			if global.OPLocate[a]["Active"] == 1 then
				CheckFlow(a)
				WaterAreaUsed(a)
				DepleatedWaterArea()
			end
		end
	global.LastWF = global.WorldFlow
	end
end

function BuiltOffShore(event) 					-- Script Event On Built
	if event.created_entity.name =="offshore-pump" then									-- If Offshore Pump Built
		--game.print("OFFSHORE PUMP BUILT")
		OPStart = game.players[1].force.fluid_production_statistics.get_input_count("water")	-- Record Amount of Water that Created Offshore Pump Starts With
		OPentity = event.created_entity													-- Variable for Event.created_entity
		OPposition = OPentity.position													-- Variable for e.Position
		OPsurface = OPentity.surface													-- Variable for e.Surface
		OPdirection = OPentity.direction												-- Variable for OPentity.direction
		global.OPCount[#global.OPCount+1] = 1
		global.OPLocate[#global.OPLocate+1] = {["OPentity"] = OPentity,["OPposition"] = {["x"] = OPposition.x, ["y"] = OPposition.y},["OPStart"]=OPStart,["OPdirection"] = OPdirection,["OPflow"] = 0, ["Active"] = 0, ["OPSameAs"] = 0, ["OPconnected"] = 0}
		GlobalWaterArea()
	else
		--game.print("Not Built A Offshore Pump")									-- If Not Offshore Pump then print Bad Times
	end
end 

function DestroyedOffShore(event) 			-- Script Event On Player Mined
	if event.entity.name =="offshore-pump-nofluid" or event.entity.name =="offshore-pump" then								-- If Offshore Pump No Fluid Mined
		--game.print("PICKED UP MY OFFSHORE PUMP")									-- Print My Offshore Pump
		OPFinished = game.players[1].force.fluid_production_statistics.get_input_count("water")	-- Record Amount of Water that Removed Offshore Pump Used
		global.OPCount[#global.OPCount] = nil								
		OPposition = event.entity.position
		table.remove(global.OPLocate)
		CWtr = 0																	-- Reset Count Water to 0
		CDpWtr = 0																	-- Reset Count Deep Water to 0
		AmountWtr = 0																-- Reset Amount of Water to 0
	else
		--game.print("Not Removed A Offshore Pump No Fluid")						-- If Not Offshore Pump then print Bad Times
	end
end	

function RestoreWater()
	if global.WaterGlobalArea then
		for a = 1, #global.WaterGlobalArea, 1 do
			if global.WaterGlobalArea[a]["Depleted"] == 1 then
				local NoTiles = global.WaterGlobalArea[a]["ShallowWater"] + global.WaterGlobalArea[a]["DeepWater"]
				for b = 1, NoTiles, 1 do
					if global.WaterGlobalArea[a]["WaterRepArea"][b]["name"] == "sand-3" then
						global.WaterGlobalArea[a]["WaterRepArea"][b]["name"] = "water"
					elseif global.WaterGlobalArea[a]["WaterRepArea"][b]["name"] == "dry-dirt" then
						global.WaterGlobalArea[a]["WaterRepArea"][b]["name"] = "deepwater"
					else
						game.print("ERROR")
					end
				end
			game.surfaces[1].set_tiles(global.WaterGlobalArea[a]["WaterRepArea"])
			--global.WaterGlobalArea[a] = nil
			end
		end
	global.WaterGlobalArea = {}
	end
end

script.on_init(WaaRInit)

script.on_event(defines.events.on_tick, CheckWater)
script.on_event(defines.events.on_built_entity, BuiltOffShore)
script.on_event(defines.events.on_player_mined_entity, DestroyedOffShore)
commands.add_command("RestoreWater", "Restores Water Areas & Clears GlobalTable",RestoreWater)